Subject: wishes, objects, and modules
From: Wouter van Oortmerssen <[email-masked]>
To: [email-masked]
Date: Sat, 31 Jul 1993 05:13:42 +0200

>> Here's my list of things I would like to have when I'm
>> programming in E:
>> 
>> MAJOR
>> 
>> * Object Oriented support (already planned anyway, I think)
 
with v2.5, you'll have object inheritance, with more on the way.
 
>> * Ability to break code into units like Pascal
 
is in v2.5. the system resembles very closely the "units" of turbopascal.
 
>> * Ability to include files for graphics/sound at the
>>   command line
 
um, you mean the chip thing you're all screaming for?
I'll _think_ about it :-)
 
>> * Proper object support, so I can use
>>   window.userport.sigbit
 
E's concept for OBJECTs is simply different from how most people
are used to program. I've indeed seen that this can be somewhat
of a nuisance, and I'd like to provide better, but it isn't
going to be simple (imagine, it also involves also ALL modules to
be radically rewritten, for a start.).
 
>> MINOR
>> 
>> * Some way of specifying more than one variable of a given
>>   type, e.g. instead of A:INT,B:INT,C:INT use A;B;C:INT
 
don't count on it.
 
>> * Some way of saving register values for programming hooks
 
v2.5 provides an installhook() function that does all the dirty
work for you.
 
>> * Don't know if there's a reason for this, but some E
>>   module object names appear to be different, e.g. mp
>>   instead of msgport, sigbit instead of mp_sigbit
 
they're different because commodore made the C and Assembly
names different, and E uses the Assembly ones. Commodore
also prefixed the names in assembly (and later some in C too),
because in assembly such a label has no type, but in E this
is superfluous, since the pointer that it is used with, has a type.
simply remember, if a name in Asm or C has a prefix, it won't have
one in E.
 
>> Remember, these are just suggestions
>> 
>> Dave.
 
--
 
>> I agree, E will have a better reputation in the Amiga community
>> if it is 100% standardized with C='s includes...
>> 
>> Alan
 
remember that E's includes already resemble those of C and Asm
quite closely (have you ever seen the names (and the directory structure)
of the includes that come with some modula2 and Oberon compilers?).
 
--
 
>> > * Object Oriented support (already planned anyway, I think)
>> 
>> > * Proper object support, so I can use
>> >   window.userport.sigbit
>> 
>> Object-orientedness was in from the first release, its just not
>> working right yet (right, Wouter?).
 
indeed. the E language has been OO just about from the beginning
(2 years ago), but my compiler-writing skills advanced slower than my
language designing skills :-)
 
>> I definately want to see proper object support like above.
 
me too.
 
>> But lets not forget to thank Wouter for a wonderful language!
 
you will be enjoying it even more now more of it gets implemented.
 
>>    Chad Freeman
 
--
 
>> I mentioned the "mp" case specifically because it caused
>> me problems. Now I know about it, I can avoid that problem
>> in the future, but how many other differences are there?
 
in Assembly, it's also called "mp" (or "MP", to be precise).
When looking through includes, take the assembly ones instead
of the C ones, which will be the same as the E ones (strip
off the prefix).
 
--
 
>> Once you become accustomed to the modules' naming conventions it's not difficult
>> 
>> to use the RKRMs to locate components in the modules.  What about all the code
>> already written against E's current modules?  I myself would not look forward to
>> converting a project the size of my EPP program (or larger!) if Wouter changes
>> the existing component names. 
 
I won't, for that reason.
 
>> Anyway, I think mp_sigbit is redundant since the
>> component belongs to an mp object.  I'm convinced Commodore set that convention
>> because of C programmers' infamous tendency to use such descriptive variable
>> names as "a" and "x".  :-)
 
:-)
 
-- Barry

Wouter
 
   ____  Wouter van Oortmerssen, [email-masked]
  / __/  "Einen Satz verstehen, heisst, wissen was der Fall ist,
 / __/    wenn er wahr ist" - Wittgenstein
/___/  ->subscribe to the E mailing list: [email-masked]<-